Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports ComTypes = System.Runtime.InteropServices.ComTypes
Imports System.Windows.Forms

'Add-in Express Add-in Module
<GuidAttribute("E1BCDE3C-CB7F-4062-88E9-88EB02A6C62B"), ProgIdAttribute("ADX_OL_Attachment_Size2_VB.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule

    Friend WithEvents AdxOlExplorerCommandBar1 As AddinExpress.MSO.ADXOlExplorerCommandBar
    Friend WithEvents AdxCommandBarButton1 As AddinExpress.MSO.ADXCommandBarButton
#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.AdxOlExplorerCommandBar1 = New AddinExpress.MSO.ADXOlExplorerCommandBar(Me.components)
        Me.AdxCommandBarButton1 = New AddinExpress.MSO.ADXCommandBarButton(Me.components)
        '
        'AdxOlExplorerCommandBar1
        '
        Me.AdxOlExplorerCommandBar1.CommandBarName = "ADX_OL_Attachment_Size2_VB"
        Me.AdxOlExplorerCommandBar1.CommandBarTag = "3059f143-e5f3-4245-896f-e542afb9095e"
        Me.AdxOlExplorerCommandBar1.Controls.Add(Me.AdxCommandBarButton1)
        Me.AdxOlExplorerCommandBar1.Temporary = True
        Me.AdxOlExplorerCommandBar1.UpdateCounter = 4
        '
        'AdxCommandBarButton1
        '
        Me.AdxCommandBarButton1.Caption = "Get attachment sizes"
        Me.AdxCommandBarButton1.ControlTag = "9e2ea574-1240-47e3-bea9-288fc39aeeba"
        Me.AdxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxCommandBarButton1.Temporary = True
        Me.AdxCommandBarButton1.UpdateCounter = 3
        '
        'AddinModule
        '
        Me.AddinName = "ADX_OL_Attachment_Size2_VB"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()
        InitializeComponent()
    End Sub

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub AdxCommandBarButton1_Click(ByVal sender As System.Object) Handles AdxCommandBarButton1.Click
        Dim explorer As Outlook._Explorer = OutlookApp.ActiveExplorer()
        If explorer IsNot Nothing Then
            Try
                Dim selection As Outlook.Selection = explorer.Selection
                If selection IsNot Nothing Then
                    Try
                        If (selection.Count > 0) Then
                            Dim mail As Outlook._MailItem = TryCast(selection.Item(1), Outlook._MailItem)
                            If mail IsNot Nothing Then
                                Try
                                    DoGetAttachmentSize(mail)
                                Finally
                                    Marshal.ReleaseComObject(mail)
                                End Try
                            End If
                        End If
                    Finally
                        Marshal.ReleaseComObject(selection)
                    End Try
                End If
            Finally
                Marshal.ReleaseComObject(explorer)
            End Try
        End If
    End Sub

    Private Sub DoGetAttachmentSize(ByRef mail As Outlook._MailItem)
        Dim attachments As Outlook.Attachments = mail.Attachments
        If attachments IsNot Nothing Then
            Try
                If attachments.Count > 0 Then
                    Dim Output As String = String.Empty
                    For i As Integer = 1 To attachments.Count
                        Dim attach As Outlook.Attachment = attachments.Item(i)
                        If attach IsNot Nothing Then
                            Try
                                If attach.Type = _
                                    Outlook.OlAttachmentType.olByValue Then

                                    Dim size As Long = GetAttachSizeMAPI( _
                                        attach.MAPIOBJECT)
                                    Output += "#" + i.ToString() + _
                                     ": " + attach.FileName + _
                                     " " + size.ToString() + _
                                     Environment.NewLine
                                End If
                            Finally
                                Marshal.ReleaseComObject(attach)
                            End Try
                        End If
                    Next i
                    If Output <> String.Empty Then MessageBox.Show(Output)
                End If
            Finally
                Marshal.ReleaseComObject(attachments)
            End Try
        End If
    End Sub

    Private Function GetAttachSizeMAPI(ByVal oMAPIObject As Object) As Long

        If (oMAPIObject Is Nothing) Then Return 0

        Dim result As String = 0
        Dim pPropValue As IntPtr = IntPtr.Zero
        Dim IUnk As IntPtr = IntPtr.Zero
        Dim IProperty As IntPtr = IntPtr.Zero
        Try
            MAPI.MAPIInitialize(IntPtr.Zero)
            IUnk = Marshal.GetIUnknownForObject(oMAPIObject)
            ' Outlook 2003 and 2007 ( IMAPIProp )
            Dim res = Marshal.QueryInterface(IUnk, MAPI.guidMAPIProp, IProperty)
            If res = MAPI.S_OK Then
                Dim oMapiProp As Object = Marshal.GetObjectForIUnknown(IProperty)
                Dim iMapiProp As IMAPIProp = TryCast(oMapiProp, IMAPIProp)
                If iMapiProp IsNot Nothing Then
                    Try
                        Dim stream As ComTypes.IStream
                        Dim IStream As IntPtr = IntPtr.Zero
                        iMapiProp.OpenProperty( _
                            MAPI.PR_ATTACH_DATA_BIN, _
                            MAPI.guidIStream, 0, 0, _
                            IStream)
                        If IStream <> IntPtr.Zero Then
                            Try
                                stream = TryCast( _
                                    Marshal.GetObjectForIUnknown(IStream), _
                                    ComTypes.IStream)
                                If stream IsNot Nothing Then
                                    Try
                                        Dim stat As ComTypes.STATSTG = Nothing
                                        stream.Stat(stat, STATFLAG.STATFLAG_NONAME)
                                        result = stat.cbSize
                                        Return result
                                    Finally
                                        Marshal.ReleaseComObject(stream)
                                    End Try
                                End If
                            Finally
                                Marshal.Release(IStream)
                            End Try
                        End If
                    Finally
                        Marshal.ReleaseComObject(oMapiProp)
                    End Try
                End If
            End If
            ' Outlook 2000 and XP ( IAttach )
            res = Marshal.QueryInterface(IUnk, MAPI.guidMAPIAttach, IProperty)
            If res = MAPI.S_OK Then
                Dim oMapiProp As Object = Marshal.GetObjectForIUnknown(IProperty)
                Dim iMapiProp As IAttach = TryCast(oMapiProp, IAttach)
                If iMapiProp IsNot Nothing Then
                    Try
                        Dim stream As ComTypes.IStream
                        Dim IStream As IntPtr = IntPtr.Zero
                        iMapiProp.OpenProperty( _
                            MAPI.PR_ATTACH_DATA_BIN, _
                            MAPI.guidIStream, 0, 0, _
                            IStream)
                        If IStream <> IntPtr.Zero Then
                            Try
                                stream = TryCast( _
                                    Marshal.GetObjectForIUnknown(IStream), _
                                    ComTypes.IStream)
                                If stream IsNot Nothing Then
                                    Try
                                        Dim stat As ComTypes.STATSTG = Nothing
                                        stream.Stat(stat, STATFLAG.STATFLAG_NONAME)
                                        result = stat.cbSize
                                        Return result
                                    Finally
                                        Marshal.ReleaseComObject(stream)
                                    End Try
                                End If
                            Finally
                                Marshal.Release(IStream)
                            End Try
                        End If
                    Finally
                        Marshal.ReleaseComObject(oMapiProp)
                    End Try
                End If
            End If
        Finally
            If (pPropValue <> IntPtr.Zero) Then
                MAPI.MAPIFreeBuffer(pPropValue)
            End If
            If (IProperty <> IntPtr.Zero) Then
                Marshal.Release(IProperty)
            End If
            If (IUnk <> IntPtr.Zero) Then
                Marshal.Release(IUnk)
            End If
        End Try
        Return result
    End Function

#Region "Extended MAPI routines"

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure SPropValue
        Public ulPropTag As UInteger
        Public dwAlignPad As UInteger
        Public Value As Long
    End Structure

    Public Enum STATFLAG
        STATFLAG_DEFAULT = 0
        STATFLAG_NONAME = 1
        STATFLAG_NOOPEN = 2
    End Enum

    <ComImport(), ComVisible(False), InterfaceType(ComInterfaceType.InterfaceIsIUnknown), _
    Guid("00020303-0000-0000-C000-000000000046")> _
    Public Interface IMAPIProp
        Function GetLastError(ByVal hResult As Integer, ByVal ulFlags As UInteger, ByRef lppMAPIError As IntPtr) As Integer
        Function SaveChanges(ByVal ulFlags As UInteger) As Integer
        Function GetProps(ByVal lpPropTagArray As IntPtr, ByVal ulFlags As UInteger, ByRef lpcValues As UInteger, ByRef lppPropArray As IntPtr) As Integer
        Function GetPropList(ByVal ulFlags As UInteger, ByRef lppPropTagArray As IntPtr) As Integer
        Function OpenProperty(ByVal ulPropTag As UInteger, ByRef lpiid As Guid, ByVal ulInterfaceOptions As UInteger, ByVal ulFlags As UInteger, ByRef lppUnk As IntPtr) As Integer
        Function SetProps(ByVal cValues As UInteger, ByVal lpPropArray As IntPtr, ByRef lppProblems As IntPtr) As Integer
        Function DeleteProps(ByVal lpPropTagArray As IntPtr, ByRef lppProblems As IntPtr) As Integer
        Function CopyTo(ByVal ciidExclude As UInteger, ByRef rgiidExclude As Guid, ByVal lpExcludeProps As IntPtr, ByVal ulUIParam As UInteger, _
            ByVal lpProgress As IntPtr, ByRef lpInterface As Guid, ByVal lpDestObj As IntPtr, ByVal ulFlags As UInteger, ByRef lppProblems As IntPtr) As Integer
        Function CopyProps(ByVal lpIncludeProps As IntPtr, ByVal ulUIParam As UInteger, ByVal lpProgress As IntPtr, ByRef lpInterface As Guid, _
            ByVal lpDestObj As IntPtr, ByVal ulFlags As UInteger, ByRef lppProblems As IntPtr) As Integer
        Function GetNamesFromIDs(ByRef lppPropTags As IntPtr, ByRef lpPropSetGuid As Guid, ByVal ulFlags As UInteger, _
            ByRef lpcPropNames As UInteger, ByRef lpppPropNames As IntPtr) As Integer
        Function GetIDsFromNames(ByVal cPropNames As UInteger, ByRef lppPropNames As IntPtr, ByVal ulFlags As UInteger, ByRef lppPropTags As IntPtr) As Integer
    End Interface

    <ComImport(), ComVisible(False), InterfaceType(ComInterfaceType.InterfaceIsIUnknown), _
    Guid("00020308-0000-0000-C000-000000000046")> _
    Public Interface IAttach
        Function GetLastError(ByVal hResult As Integer, ByVal ulFlags As UInteger, ByRef lppMAPIError As IntPtr) As Integer
        Function SaveChanges(ByVal ulFlags As UInteger) As Integer
        Function GetProps(ByVal lpPropTagArray As IntPtr, ByVal ulFlags As UInteger, ByRef lpcValues As UInteger, ByRef lppPropArray As IntPtr) As Integer
        Function GetPropList(ByVal ulFlags As UInteger, ByRef lppPropTagArray As IntPtr) As Integer
        Function OpenProperty(ByVal ulPropTag As UInteger, ByRef lpiid As Guid, ByVal ulInterfaceOptions As UInteger, ByVal ulFlags As UInteger, ByRef lppUnk As IntPtr) As Integer
        Function SetProps(ByVal cValues As UInteger, ByVal lpPropArray As IntPtr, ByRef lppProblems As IntPtr) As Integer
        Function DeleteProps(ByVal lpPropTagArray As IntPtr, ByRef lppProblems As IntPtr) As Integer
        Function CopyTo(ByVal ciidExclude As UInteger, ByRef rgiidExclude As Guid, ByVal lpExcludeProps As IntPtr, ByVal ulUIParam As UInteger, _
            ByVal lpProgress As IntPtr, ByRef lpInterface As Guid, ByVal lpDestObj As IntPtr, ByVal ulFlags As UInteger, ByRef lppProblems As IntPtr) As Integer
        Function CopyProps(ByVal lpIncludeProps As IntPtr, ByVal ulUIParam As UInteger, ByVal lpProgress As IntPtr, ByRef lpInterface As Guid, _
            ByVal lpDestObj As IntPtr, ByVal ulFlags As UInteger, ByRef lppProblems As IntPtr) As Integer
        Function GetNamesFromIDs(ByRef lppPropTags As IntPtr, ByRef lpPropSetGuid As Guid, ByVal ulFlags As UInteger, _
            ByRef lpcPropNames As UInteger, ByRef lpppPropNames As IntPtr) As Integer
        Function GetIDsFromNames(ByVal cPropNames As UInteger, ByRef lppPropNames As IntPtr, ByVal ulFlags As UInteger, ByRef lppPropTags As IntPtr) As Integer
    End Interface

    Friend Class MAPI
        Public Shared ReadOnly S_OK As UInteger = 0

        Public Shared ReadOnly PT_LONG As UInteger = 3
        Public Shared ReadOnly PT_BINARY As UInteger = &H102

        Public Shared ReadOnly PR_ATTACH_SIZE As UInteger = (PT_LONG Or (&HE20 << 16))
        Public Shared ReadOnly PR_ATTACH_DATA_BIN As UInteger = (PT_BINARY Or (&H3701 << 16))

        Public Shared ReadOnly IID_IStream As String = "0000000c-0000-0000-C000-000000000046"
        Public Shared ReadOnly IID_IMAPIProp As String = "00020303-0000-0000-C000-000000000046"
        Public Shared ReadOnly IID_IAttachment As String = "00020308-0000-0000-C000-000000000046"
        Public Shared guidIStream As Guid = New Guid(IID_IStream)
        Public Shared guidMAPIProp As Guid = New Guid(IID_IMAPIProp)
        Public Shared guidMAPIAttach As Guid = New Guid(IID_IAttachment)

        <DllImport("MAPI32.DLL", CharSet:=CharSet.Ansi, EntryPoint:="HrGetOneProp@12")> _
        Public Shared Function HrGetOneProp(ByVal pmp As IntPtr, ByVal ulPropTag As Integer, ByRef ppProp As IntPtr) As Integer
        End Function

        <DllImport("MAPI32.DLL", CharSet:=CharSet.Ansi, EntryPoint:="MAPIFreeBuffer@4")> _
        Public Shared Sub MAPIFreeBuffer(ByVal lpBuffer As IntPtr)
        End Sub

        <DllImport("MAPI32.DLL", CharSet:=CharSet.Ansi, EntryPoint:="MAPIInitialize@4")> _
        Public Shared Function MAPIInitialize(ByVal lpMapiInit As IntPtr) As Integer
        End Function
    End Class

#End Region
End Class

